// Jakub Hlavacek - Hippo Games - GPL
// piskvorky * v0.04 * 22.8.00
// 22.8.2005 - linux version
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

#ifndef random
#define random   rand
#endif
#ifndef srandom
#define srandom  srand
#endif

#include "allegro.h"

#define INFO
#define X_CT 34  //ctverecku ve smeru x ( pocet sloupcu 0..X_CT-1)
#define Y_CT 34  //ctverecku ve smeru y ( pocet radek   0..Y_CT-1)
#define V_CT 14  //velikost ctverecku
#define P_CT 5   //pulka ctverecku ( V_CT/2-2)

#define B_PO 162
#define B_POz 164
#define B_O 47
#define B_X 52
#define B_5 39
#define B_L 28

/*#define B_PO 30
#define B_O 23
#define B_X 23
#define B_5 16
#define B_L 24*/

#define O( x, y) circle( ctpapir, x, y, P_CT-1, /*14*/B_O);
#define X( x, y) { line( ctpapir, (x)-P_CT+1, (y)-P_CT+1, (x)+P_CT-1, (y)+P_CT-1, /*13*/B_X);\
                   line( ctpapir, (x)+P_CT-1, (y)-P_CT+1, (x)-P_CT+1, (y)+P_CT-1, /*13*/B_X); }
#define N( x, y) rectfill( ctpapir, (x)-P_CT, (y)-P_CT, (x)+P_CT, (y)+P_CT, B_PO);
#define Cc( x, y) rect( ctpapir, (x)*V_CT+1, (y)*V_CT+1, (x+1)*V_CT-1, (y+1)*V_CT-1, B_PO);
#define Cb( x, y, b) rect( ctpapir, (x)*V_CT+1, (y)*V_CT+1, (x+1)*V_CT-1, (y+1)*V_CT-1, (b));

typedef unsigned char TPAPIR[X_CT+8][Y_CT+8];    //  00000000
                                                 //        01 o
TPAPIR papir;                                    //        10 x
int cx, cy, ox, oy, xx, xy;                      //     ---00 KB o
BITMAP *ctpapir;                                 //  ---   00 KB x
BITMAP *my_cursor;

int xo( int x, int y, unsigned char co)
  { x=x*V_CT+V_CT/2; y=y*V_CT+V_CT/2;
    N( x, y)
    if ( (co & 1) == 1)      O( x, y)
    else if ( (co & 2) == 2) X( x, y)
    else {
      int i;
      for ( i=0; i<(co>>2 & 7); i++) putpixel( screen, x-P_CT+i*2, y-P_CT, 14);
      for ( i=0; i<(co>>5 & 7); i++) putpixel( screen, x-P_CT+i*2, y+P_CT, 13);
    }
    return( 0);
  }//int xo( int x, int y, unsigned char co)

int kresli_papir( BITMAP *ctp)
  {
    int i0, i1;
    clear_to_color( ctp, B_PO);
    for ( i0=0; i0<=X_CT; i0++) line( ctp, i0*V_CT, 0*V_CT, i0*V_CT, Y_CT*V_CT, B_L);
    for ( i0=0; i0<=Y_CT; i0++) line( ctp, 0*V_CT, i0*V_CT, X_CT*V_CT, i0*V_CT, B_L);
  }//int kresli_papir()

int ox5vr( TPAPIR p, int B, BITMAP *ctp)
  {
    int i0, i1, i2, ix, iy, vekt, b0, b1, ret=0;
    for ( i0=4; i0<X_CT+4; i0++) for ( i1=4; i1<Y_CT+4; i1++)
    if ( p[i0][i1] & 3) for ( vekt=0; vekt<4; vekt++) {
      switch (vekt) { case 0: ix= 1; iy= 1; break; case 1: ix= 0; iy= 1; break; case 2: ix=-1; iy= 1; break; case 3: ix=-1; iy= 0; /*break; case 4: ix=-1; iy=-1; break; case 5: ix= 0; iy=-1; break; case 6: ix= 1; iy=-1; break; case 7: ix= 1; iy= 0; break;*/ }
      b0=1; b1=1;
      for ( i2=2; i2<7; i2++) {//sloupce
        if ( b0) b0=b0 && p[i0+ix*(i2-4)][i1+iy*(i2-4)] & 1;
        if ( b1) b1=b1 && p[i0+ix*(i2-4)][i1+iy*(i2-4)] & 2; }
      if ( b0) { if ( B) line( ctp, (i0+ix*(-2)-4)*V_CT+V_CT/2, (i1+iy*(-2)-4)*V_CT+V_CT/2, (i0+ix*2-4)*V_CT+V_CT/2, (i1+iy*2-4)*V_CT+V_CT/2, B_5); ret=1; } else
      if ( b1) { if ( B) line( ctp, (i0+ix*(-2)-4)*V_CT+V_CT/2, (i1+iy*(-2)-4)*V_CT+V_CT/2, (i0+ix*2-4)*V_CT+V_CT/2, (i1+iy*2-4)*V_CT+V_CT/2, B_5); ret=2; }
    }
    return ret;
  }//int ox5vr( TPAPIR p, int B, BITMAP *ctp)

int kresli( TPAPIR p)
  {
    int i0, i1;
    for ( i0=0; i0<X_CT; i0++) for ( i1=0; i1<Y_CT; i1++)
      xo( i0, i1, p[i0+4][i1+4]);
    ox5vr( p, 1, ctpapir);
    blit( ctpapir, screen, 0, 0, 0, 0, ctpapir->w, ctpapir->h);
  }//int kresli( TPAPIR p)

unsigned char mat_KB[ ][9]={{0,1,1,0,0,0,3,3,3},
                            {0,1,0,1,0,0,3,3,3},
                            {3,0,1,1,0,0,3,3,3},
                            {3,0,1,0,0,1,0,3,3},
                            {3,3,0,1,0,1,0,3,3},
                            {3,3,0,1,0,0,1,0,3},
                            {3,3,3,0,0,1,1,0,3},
                            {3,3,3,0,0,1,0,1,0},
                            {3,3,3,0,0,0,1,1,0}};  //

/*unsigned char mat_4KB[ ][9]={{1,1,1,1,0,3,3,3,3},
                               {3,1,1,1,0,1,3,3,3},
                               {3,3,1,1,0,1,1,3,3},
                               {3,3,3,1,0,1,1,1,3},
                               {3,3,3,3,0,1,1,1,1}};  //*/

#define je_u_ostatnich(p)\
       ((p[i0-2][i1-2]&3) || (p[i0-1][i1-2]&3) || (p[i0  ][i1-2] & 3) || (p[i0+1][i1-2] & 3) || (p[i0+2][i1-2] & 3)\
      ||(p[i0-2][i1-1]&3) || (p[i0-1][i1-1]&3) || (p[i0  ][i1-1] & 3) || (p[i0+1][i1-1] & 3) || (p[i0+2][i1-1] & 3)\
      ||(p[i0-2][i1  ]&3) || (p[i0-1][i1  ]&3) ||                        (p[i0+1][i1  ] & 3) || (p[i0+2][i1  ] & 3)\
      ||(p[i0-2][i1+1]&3) || (p[i0-1][i1+1]&3) || (p[i0  ][i1+1] & 3) || (p[i0+1][i1+1] & 3) || (p[i0+2][i1+1] & 3)\
      ||(p[i0-2][i1+2]&3) || (p[i0-1][i1+2]&3) || (p[i0  ][i1+2] & 3) || (p[i0+1][i1+2] & 3) || (p[i0+2][i1+2] & 3))


int klicovy_bod( TPAPIR p, int x, int y)
  { // jen okolo bodu, kam se hralo ( xy+-4)
    int i0, i1, i2, i3, ix, iy, vekt, b=0, p0, p1; x+=4; y+=4;
    //for ( i0=x-4; i0<=x+4; i0++) for ( i1=y-4; i1<=y+4; i1++)
    for ( i0=4; i0<X_CT+4; i0++) for ( i1=4; i1<Y_CT+4; i1++)
    if ( (p[i0][i1] & 3)==0 && je_u_ostatnich(p)) {
      p[i0][i1]=0;
      for ( vekt=0; vekt<4; vekt++) {
        switch (vekt) { case 0: ix= 1; iy= 1; break; case 1: ix= 0; iy= 1; break; case 2: ix=-1; iy= 1; break; case 3: ix=-1; iy= 0; break; /*case 4: ix=-1; iy=-1; break; case 5: ix= 0; iy=-1; break; case 6: ix= 1; iy=-1; break; case 7: ix= 1; iy= 0; break;*/ }
        if ( (p[i0][i1]>>2 & 7) != 4) {
        /*<<(-)*/i2=4; while ( (--i2>=0) && ( i0+ix*(i2-4)>=0) && ( i0+ix*(i2-4)<X_CT) && ( i1+iy*(i2-4)>=0) && ( i1+iy*(i2-4)<Y_CT) && ( ( p[ i0+ix*(i2-4)][ i1+iy*(i2-4)] & 2) != 2) );
        /*>>(+)*/i3=4; while ( (++i3<=8) && ( i0+ix*(i3-4)>=0) && ( i0+ix*(i3-4)<X_CT) && ( i1+iy*(i3-4)>=0) && ( i1+iy*(i3-4)<Y_CT) && ( ( p[ i0+ix*(i3-4)][ i1+iy*(i3-4)] & 2) != 2) );
        i2=(++i2 == 4)? 9:i2*2;
        p0=(--i3 == 4)?-1:(i3-4)*2;
        for ( ; i2<=p0; i2++) {//radky
          switch (i2){ case 0: case 1: i3=0; break; case 2: case 3: i3=1; break; case 4: case 5: i3=2; break; case 6: case 7: case 8: i3=3; break; }
          switch (i2){ case 0: case 1: case 2: p1=6; break; case 3: case 4: p1=7; break; case 5: case 6: p1=8; break; case 7: case 8: p1=9; break; }
          b=1;
          for ( ; i3<p1; i3++) if ( b && (i3!=4)) //sloupce //while ( i3++,(b==1) && (i3<p1) )  if (i3!=4)
            b=b && ( mat_KB[i2][i3]==0 || p[i0+ix*(i3-4)][i1+iy*(i3-4)] & 1 );
          if ( b) p[i0][i1]=(( p[i0][i1]>>2 & 7)+1)<<2 | ( p[i0][i1] & ~(7<<2));
        }}
        for ( i2=0; i2<5; i2++) {//radky
          b=1; i3=i2; p1=i3+5;
          for ( ; i3<p1; i3++) if ( b && (i3!=4)) //sloupce //while ( i3++,(b==1) && (i3<p1) )  if (i3!=4)
            b=b && ( p[i0+ix*(i3-4)][i1+iy*(i3-4)] & 1 );
          if ( b) { p[i0][i1]=4<<2; break; }
        }

        if ( (p[i0][i1]>>5 & 7) != 4) {
        /*<<(-)*/i2=4; while ( (--i2>=0) && ( i0+ix*(i2-4)>=0) && ( i0+ix*(i2-4)<X_CT) && ( i1+iy*(i2-4)>=0) && ( i1+iy*(i2-4)<Y_CT) && ( ( p[ i0+ix*(i2-4)][ i1+iy*(i2-4)] & 1) != 1) );
        /*>>(+)*/i3=4; while ( (++i3<=8) && ( i0+ix*(i3-4)>=0) && ( i0+ix*(i3-4)<X_CT) && ( i1+iy*(i3-4)>=0) && ( i1+iy*(i3-4)<Y_CT) && ( ( p[ i0+ix*(i3-4)][ i1+iy*(i3-4)] & 1) != 1) );
        i2=(++i2 == 4)? 9:i2*2;
        p0=(--i3 == 4)?-1:(i3-4)*2;
        for ( ; i2<=p0; i2++) {//radky
          switch (i2){ case 0: case 1: i3=0; break; case 2: case 3: i3=1; break; case 4: case 5: i3=2; break; case 6: case 7: case 8: i3=3; break; }
          switch (i2){ case 0: case 1: case 2: p1=6; break; case 3: case 4: p1=7; break; case 5: case 6: p1=8; break; case 7: case 8: p1=9; break; }
          b=1;
          for ( ; i3<p1; i3++) if ( b && (i3!=4)) //sloupce // while ( i3++,(b==1) && (i3<p1) ) if (i3ss!=4)
            b=b && ( mat_KB[i2][i3] == 0 || p[i0+ix*(i3-4)][i1+iy*(i3-4)] & 2 );
          if ( b) p[i0][i1]=(( p[i0][i1]>>5 & 7)+1)<<5 | ( p[i0][i1] & ~(7<<5));
        }}
        for ( i2=0; i2<5; i2++) {//radky
          b=1; i3=i2; p1=i3+5;
          for ( ; i3<p1; i3++) if ( b && (i3!=4)) //sloupce // while ( i3++,(b==1) && (i3<p1) ) if (i3!=4)
            b=b && ( p[i0+ix*(i3-4)][i1+iy*(i3-4)] & 2 );
          if ( b) { p[i0][i1]=4<<5; break; }
        }
      }

    }
  }//int klicovy_bod( TPAPIR p, int x, int y)

int potapec=0, POTAPEC=0;
int tah( TPAPIR p, char kdo, int *x, int *y)
//vysledek
//  10<<2  tah & 3    vyhraje
//   5<<2  tah & 3 neprohraje
//   0<<2  tah & 3   prohraje
  {
    int i0, i1, p0, p1, p2, p3, b0=0;
    struct {
      int poc, pocv, pocKB, x, y; //
    } h12[2];
    TPAPIR pp; //pole pp neni potreba ?
    if ( *x==0 && *x==0) { *x=X_CT/2; *y=Y_CT/2; return( kdo || 5<<2); }
    for ( i0=0; i0<2; i0++) { h12[i0].poc=0; h12[i0].pocv=0; h12[i0].pocKB=0; }
//p do pp kopirovat pomoci pointeru
    for ( i0=0; i0<X_CT+8; i0++) for ( i1=0; i1<Y_CT+8; i1++) pp[i0][i1]=p[i0][i1];
    klicovy_bod( pp, *x, *y);
    for ( i0=4; i0<X_CT+4; i0++) for ( i1=4; i1<Y_CT+4; i1++)
    if ( (pp[i0][i1] & 3)==0 && je_u_ostatnich(pp)) {
      if ( (p1=pp[i0][i1]>>2 & 7)==h12[0].pocKB) { h12[0].poc++; if ( h12[0].pocKB>1) h12[0].pocv++; if ( random()%h12[0].poc==0) { h12[0].x=i0; h12[0].y=i1; }
      } else if ( p1>h12[0].pocKB) { h12[0].pocKB=p1; h12[0].poc=1; if ( h12[0].pocKB>1) h12[0].pocv++; h12[0].x=i0; h12[0].y=i1; }
      if ( (p2=pp[i0][i1]>>5 & 7)==h12[1].pocKB) { h12[1].poc++; if ( h12[1].pocKB>1) h12[1].pocv++; if ( random()%h12[1].poc==0) { h12[1].x=i0; h12[1].y=i1; }
      } else if ( p2>h12[1].pocKB) { h12[1].pocKB=p2; h12[1].poc=1; if ( h12[1].pocKB>1) h12[1].pocv++; h12[1].x=i0; h12[1].y=i1; }
    }

    if ( h12[kdo-1].pocKB>=h12[2-kdo].pocKB) {
      *x=h12[kdo-1].x-4; *y=h12[kdo-1].y-4; if ( h12[kdo-1].pocKB>1) return( kdo || 10<<2);
    } else { // h12[kdo-1].pocKB<h12[2-kdo].pocKB
      *x=h12[2-kdo].x-4; *y=h12[2-kdo].y-4; //if ( h12[2-kdo].pocKB>1) return( kdo || 5<<2);
    }

    if ( potapec<POTAPEC) { // kdyz je potapec>0 tak neni treba uchovavat, kam se bude hrat
      potapec++; p0=0; h12[1].x=*x+4; h12[1].y=*y+4; h12[0].poc=0;
      for ( i0=4; i0<X_CT+4; i0++) for ( i1=4; i1<Y_CT+4; i1++)
      if ( (pp[i0][i1] & 3)==0 && je_u_ostatnich(pp)) {
        pp[i0][i1]=kdo;
        h12[0].x=i0; h12[0].y=i1; p1=tah( pp, 3-kdo, &h12[0].x, &h12[0].y);
        //if ( (p1 & 3)==kdo) { if ( p1>>2>p0) { p0=p1>>2;      h12[1].x=i0; h12[1].y=i1; h12[0].poc=1; } else if ( p1>>2==p0) { h12[0].poc++; if ( random()%h12[0].poc==0) { h12[1].x=i0; h12[1].y=i1; } } } else
        if ( p1>>2<p0) {
          p0=10-(p1>>2); h12[1].x=i0; h12[1].y=i1; h12[0].poc=1;
        } else if ( p1>>2==p0) {
          h12[0].poc++; if ( random()%h12[0].poc==0) { h12[1].x=i0; h12[1].y=i1; }
        }
        pp[i0][i1]=0;
      }
      potapec--; *x=h12[1].x-4; *y=h12[1].y-4; return( kdo || p0<<2);
    } else return( kdo || 5<<2);

  }//int tah( TPAPIR p, char kdo, int *x, int *y)



int vysl_dialog_proc(int msg, DIALOG *d, int c);
int d_play_proc(int msg, DIALOG *d, int c);
int papir_dialog_proc(int msg, DIALOG *d, int c);
int d_mybutton_proc(int msg, DIALOG *d, int c);

#define OC "O Comp "
#define OH "O Human"
#define XC "X Comp "
#define XH "X Human"

DIALOG the_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
/*0*/{ d_clear_proc,      0,    0,    0,    0,    0,    B_POz, 0,   0,       0,    0,    NULL },
/*1*/{ papir_dialog_proc, 0,    0, X_CT*V_CT, Y_CT*V_CT, 0, 0, 0,   /*D_GOTFOCUS*/0,0,  0,    NULL },
/*2*/{ vysl_dialog_proc,  X_CT*V_CT+3, 0, 640-X_CT*V_CT+3, 30, 0, 0, 0, 0,   0,    0,    NULL },
/*3*/{ d_button_proc,     0,    0,    80,   16,   15,   0,    0,    D_EXIT,  0,    0,    "Exit" },
/*4*/{ d_button_proc,     0,    0,    80,   16,   15,   0,    0,    0,       0,    0,    "Sound" },
/*5*/{ d_mybutton_proc,   0,    0,    80,   16,   15,   0,    0,    D_EXIT,  1,    1,    XC },
/*6*/{ d_mybutton_proc,   0,    0,    80,   16,   15,   0,    0,    D_EXIT,  0,    0,    OH },
/*7*/{ d_play_proc,       0,    0,    80,   16,   15,   0,    0,    D_EXIT,  0,    0,    "Play" },
/*8*/{ NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL }
};
int *pl1, *pl2;     //0-human; 1-comp;  10-na tahu

int d_mybutton_proc(int msg, DIALOG *d, int c)
{
  int ret;
  ret=d_button_proc( msg, d, c);
  if ( ret==D_CLOSE)
    {
      if ( d->d2==0) {
        if ( (d->d1&1)==0) { d->d1=d->d1 | 1; d->dp=OC; }
        else {               d->d1=d->d1 & 2; d->dp=OH; }
      } else {
        if ( (d->d1&1)==0) { d->d1=d->d1 | 1; d->dp=XC; }
        else {               d->d1=d->d1 & 2; d->dp=XH; }
      }
      return D_REDRAW;
    }
  return ret;
}//int d_mybutton_proc(int msg, DIALOG *d, int c)

int pocet_o=0, pocet_x=0;
BITMAP *vysl;
int vysl_dialog_proc(int msg, DIALOG *d, int c)
{
  switch (msg) {

    case MSG_START:
      vysl=create_bitmap( d->w, d->h); d->dp=vysl;
      clear_to_color( d->dp, B_POz);
      circle( d->dp, V_CT/2, V_CT/2, P_CT-1, B_O);
      line( d->dp, V_CT/2-P_CT+1, V_CT*3/2-P_CT+1, V_CT/2+P_CT-1, V_CT*3/2+P_CT-1, B_X);
      line( d->dp, V_CT/2+P_CT-1, V_CT*3/2-P_CT+1, V_CT/2-P_CT+1, V_CT*3/2+P_CT-1, B_X);
    break;
    case MSG_END:
      destroy_bitmap( d->dp);
    break;
    case MSG_DRAW:
      if ( pocet_o>0) if ( pocet_o%5==0) line( d->dp, 15+(pocet_o-5)*3, V_CT  /2+3, 15+pocet_o*3, V_CT  /2-3, B_O);
      else                               line( d->dp, 15+ pocet_o   *3, V_CT  /2-5, 15+pocet_o*3, V_CT  /2+5, B_O);
      if ( pocet_x>0) if ( pocet_x%5==0) line( d->dp, 15+(pocet_x-5)*3, V_CT*3/2+3, 15+pocet_x*3, V_CT*3/2-3, B_X);
      else                               line( d->dp, 15+ pocet_x   *3, V_CT*3/2-5, 15+pocet_x*3, V_CT*3/2+5, B_X);

      blit( d->dp, screen, 0, 0, d->x, d->y, d->w, d->h);
    break;
  }
  return D_O_K;
}


int d_play_proc(int msg, DIALOG *d, int c)
{
  int i0, i1, ret=d_button_proc( msg, d, c);
  if ( ret == D_EXIT) {
    pocet_o=0; pocet_x=0; *pl1=*pl1 | 2; *pl2=*pl2 & 1; cx=0; cy=0; ox=cx; oy=cy; xx=cx; xy=cy;
    rectfill(vysl, 15, 0, vysl->w, vysl->h, B_POz);
    kresli_papir( ctpapir);
    //position_mouse( d->x+d->w/2, d->y+d->h/2);
    for ( i0=0; i0<X_CT+8; i0++) for ( i1=0; i1<Y_CT+8; i1++) papir[i0][i1]=0;
    //SEND_MESSAGE( d, MSG_GOTMOUSE, 0);
    return D_REDRAW;
  }

  return ret;
}

/* custom dialog procedure for the clock object */
#define KRESLI_DIALOG show_mouse( NULL); SEND_MESSAGE( d, MSG_DRAW, 0); show_mouse( screen);
int bmous=1, x_x, y_x, click=0;
int papir_dialog_proc(int msg, DIALOG *d, int c)
{
  int i0, i1;
   /* process the message */
  switch (msg) {

    /* initialise when we get a start message */
    case MSG_START:
      click=0; cx=0; cy=0; ox=cx; oy=cy; xx=cx; xy=cy;
      position_mouse( d->x+d->w/2, d->y+d->h/2);
      for ( i0=0; i0<X_CT+8; i0++) for ( i1=0; i1<Y_CT+8; i1++) papir[i0][i1]=0;
      if ( (pocet_o>=10) || (pocet_x>=10)) {
        pocet_o=0; pocet_x=0; rectfill(vysl, 15, 0, vysl->w, vysl->h, B_POz);
      }
      if ( (pocet_o+pocet_x) % 2) { *pl1=*pl1 & 1; *pl2=*pl2 | 2; } else { *pl1=*pl1 | 2; *pl2=*pl2 & 1; }
      show_mouse( NULL); kresli_papir( ctpapir); kresli( papir); show_mouse( screen);
      SEND_MESSAGE( d, MSG_GOTMOUSE, 0);
      //vysl_dialog_proc( MSG_USER, &the_dialog[2], 0);
    break;

    case MSG_END:
    break;

    case MSG_LOSTMOUSE:
      bmous=0; Cc( cx, cy) set_mouse_sprite( NULL); KRESLI_DIALOG
    break;
    case MSG_GOTMOUSE:
      bmous=1; cx=mouse_x/V_CT; cy=mouse_y/V_CT; Cb( cx, cy, B_5) set_mouse_sprite( my_cursor); KRESLI_DIALOG
    break;

    case MSG_CLICK:
      if ( click) {
        click=0; SEND_MESSAGE( d, MSG_START, 0); return D_REDRAW;
      }
      else if ( *pl1==2) { if ( (papir[cx+4][cy+4] & 3)==0) {
        papir[cx+4][cy+4]=1; Cc( ox, oy) ox=cx; oy=cy; *pl1=0; *pl2=*pl2 | 2;
        kresli( papir);
        if ( ox5vr( papir, 1, ctpapir)) {
          pocet_o++; click=1;
        }
      } } else if ( *pl2==2) if ( (papir[cx+4][cy+4] & 3)==0) {
        papir[cx+4][cy+4]=2; Cc( xx, xy) xx=cx; xy=cy; *pl2=0; *pl1=*pl1 | 2;
        kresli( papir);
        if ( ox5vr( papir, 1, ctpapir)) {
          pocet_x++; click=1;
        }
      }
    break;

    case MSG_IDLE:
      if ( bmous) {
        if ( mouse_x/V_CT != cx) { Cc( cx, cy) cx=mouse_x/V_CT; Cb( cx, cy, B_5) KRESLI_DIALOG }
        if ( mouse_y/V_CT != cy) { Cc( cx, cy) cy=mouse_y/V_CT; Cb( cx, cy, B_5) KRESLI_DIALOG }
      }
      if ( !click)
      if ( *pl1==3) {
        Cc( ox, oy) ox=xx; oy=xy; tah(papir, 1, &ox, &oy); papir[ox+4][oy+4]=1; Cb( ox, oy, B_O)
        kresli( papir); *pl1=1; *pl2=*pl2 | 2;
        if ( ox5vr( papir, 1, ctpapir)) {
          pocet_o++; click=1;//SEND_MESSAGE( d, MSG_START, 0);
          //???????????????????????????????????????????
          //vysl_dialog_proc(MSG_DRAW, &the_dialog[2], 0); //return D_REDRAW;
          //???????????????????????????????????????????
        }
      } else if ( *pl2==3) {
        Cc( xx, xy) xx=ox; xy=oy; tah(papir, 2, &xx, &xy); papir[xx+4][xy+4]=2; Cb( xx, xy, B_X)
        kresli( papir); *pl2=1; *pl1=*pl1 | 2;
        if ( ox5vr( papir, 1, ctpapir)) {
          pocet_x++; click=1; //SEND_MESSAGE( d, MSG_START, 0);
          //???????????????????????????????????????????
          //vysl_dialog_proc(MSG_DRAW, &the_dialog[2], 0); //return D_REDRAW;
          //???????????????????????????????????????????
        }
      }
    break;

    case MSG_CHAR:
      if ( c==  KEY_LEFT) { while(key[  KEY_LEFT]); if ( cx>0   ) { position_mouse( d->x+(cx-1)*V_CT, d->y+cy*V_CT); } return D_USED_CHAR; }
      if ( c== KEY_RIGHT) { while(key[ KEY_RIGHT]); if ( cx<X_CT-1) { position_mouse( d->x+(cx+1)*V_CT, d->y+cy*V_CT); } return D_USED_CHAR; }
      if ( c==    KEY_UP) { while(key[    KEY_UP]); if ( cy>0   ) { position_mouse( d->x+cx*V_CT, d->y+(cy-1)*V_CT); } return D_USED_CHAR; }
      if ( c==  KEY_DOWN) { while(key[  KEY_DOWN]); if ( cy<Y_CT-1) { position_mouse( d->x+cx*V_CT, d->y+(cy+1)*V_CT); } return D_USED_CHAR; }
      if ( c== KEY_PLUS_PAD) { textprintf( screen, font, 2, 2, 15, "%d", ++POTAPEC); while(key[ KEY_PLUS_PAD]); textprintf( screen, font, 2, 2, 0, "%d", POTAPEC); return D_USED_CHAR; }
      if ( c==KEY_MINUS_PAD) { textprintf( screen, font, 2, 2, 15, "%d", --POTAPEC); while(key[KEY_MINUS_PAD]); textprintf( screen, font, 2, 2, 0, "%d", POTAPEC); return D_USED_CHAR; }
      if ( c==   KEY_DEL) { while(key[  KEY_DEL]); papir[cx+4][cy+4]=0; kresli( papir); return D_USED_CHAR; }
      if ( c==KEY_INSERT) { while(key[KEY_INSERT]); klicovy_bod( papir, cx, cy); kresli( papir); return D_USED_CHAR; }
      if ( c==  KEY_HOME) { while(key[  KEY_HOME]); if ( (papir[cx+4][cy+4] & 3)==0) { papir[cx+4][cy+4]=1; kresli( papir); } return D_USED_CHAR; }
      if ( c==   KEY_END) { while(key[   KEY_END]); if ( (papir[cx+4][cy+4] & 3)==0) { papir[cx+4][cy+4]=2; kresli( papir); } return D_USED_CHAR; }
      if ( c== KEY_ENTER) { while(key[ KEY_ENTER]);
        if ( (papir[cx+4][cy+4] & 3)==0) {
          papir[cx+4][cy+4]=1;
          Cc( cx, cy) tah(papir, 2, &cx, &cy); papir[cx+4][cy+4]=2; Cb( cx, cy, B_5) /*ox5vr( papir, 1, ctpapir);*/ kresli( papir);
        } return D_USED_CHAR; }
    break;

    case MSG_DRAW:
      blit( ctpapir, screen, 0, 0, d->x, d->y, d->w+1, d->h+1);
    break;
  }

  return D_O_K;
}


int main(int argc, char *argv[])
{
  int i0, i1, i2, i3;
  srandom( time( NULL));
  allegro_init();
  install_keyboard();
  install_mouse();
  install_timer();

  if ( set_gfx_mode( GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0) != 0) { allegro_exit(); printf( "Error set_gfx_mode() \n"); return 1; }
  set_color_depth( 8);

  pl1=&the_dialog[6].d1;
  pl2=&the_dialog[5].d1;

  the_dialog[3].x = SCREEN_W-the_dialog[3].w-1; the_dialog[3].y = SCREEN_H-the_dialog[3].h-1;
  the_dialog[4].x = SCREEN_W-the_dialog[4].w-1; the_dialog[4].y = the_dialog[3].y-the_dialog[4].h;
  the_dialog[5].x = SCREEN_W-the_dialog[5].w-1; the_dialog[5].y = the_dialog[4].y-the_dialog[5].h;
  the_dialog[6].x = SCREEN_W-the_dialog[6].w-1; the_dialog[6].y = the_dialog[5].y-the_dialog[6].h;
  the_dialog[7].x = SCREEN_W-the_dialog[7].w-1; the_dialog[7].y = the_dialog[6].y-the_dialog[7].h;

  ctpapir=create_bitmap( X_CT*V_CT+1, Y_CT*V_CT+1);
  for ( i0=0; i0<X_CT+8; i0++) for ( i1=0; i1<Y_CT+8; i1++) papir[i0][i1]=0;
  my_cursor=create_bitmap( 5, 5); clear( my_cursor); circlefill( my_cursor, 3, 3, 1, B_5);

  do_dialog(the_dialog, -1);

  destroy_bitmap( ctpapir);
  destroy_bitmap( my_cursor);
  return 0;
}
END_OF_MAIN();
